use serde::{Serialize, Deserialize};
#[derive(Serialize, Deserialize)]
pub struct Module {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@size")]
    pub size: String,
    #[serde(rename = "@amod")]
    pub amod: String,
    #[serde(rename = "@type")]
    pub module_type: String,
    #[serde(rename = "@desc")]
    pub desc: String,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub block: Vec<ModuleBlock>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlock {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@size")]
    pub size: String,
    #[serde(rename = "@decoder")]
    pub decoder: String,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub block: Vec<ModuleBlockBlock>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlock {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@size")]
    pub size: String,
    #[serde(rename = "@modf")]
    pub modf: String,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub block: Vec<ModuleBlockBlockBlock>,
    pub register: Vec<ModuleBlockBlockRegister>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockBlock {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@size")]
    pub size: String,
    #[serde(rename = "@desc")]
    pub desc: Option<String>,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub register: Vec<ModuleBlockBlockBlockRegister>,
    pub block: Vec<ModuleBlockBlockBlockBlock>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockBlockRegister {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@mask")]
    pub mask: Option<String>,
    #[serde(rename = "@offset")]
    pub offset: Option<String>,
    #[serde(rename = "@multiple")]
    pub multiple: Option<String>,
    #[serde(rename = "@default")]
    pub default: Option<String>,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub field: Vec<ModuleBlockBlockBlockRegisterField>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockBlockRegisterField {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@mask")]
    pub mask: String,
    #[serde(rename = "@offset")]
    pub offset: Option<String>,
    #[serde(rename = "@multiple")]
    pub multiple: Option<String>,
    #[serde(rename = "@default")]
    pub default: Option<String>,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub value: Vec<Value>,
}

#[derive(Serialize, Deserialize)]
pub struct Value {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@data")]
    pub data: String,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockBlockBlock {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub register: Vec<ModuleBlockBlockBlockBlockRegister>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockBlockBlockRegister {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@offset")]
    pub offset: Option<String>,
    #[serde(rename = "@multiple")]
    pub multiple: Option<String>,
    #[serde(rename = "@mask")]
    pub mask: Option<String>,
    #[serde(rename = "$text")]
    pub text: Option<String>,
    pub field: Vec<BlockBlockBlockBlockRegisterField>,
}

#[derive(Serialize, Deserialize)]
pub struct BlockBlockBlockBlockRegisterField {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@mask")]
    pub mask: String,
    #[serde(rename = "@multiple")]
    pub multiple: Option<String>,
    #[serde(rename = "@offset")]
    pub offset: Option<String>,
}

#[derive(Serialize, Deserialize)]
pub struct ModuleBlockBlockRegister {
    #[serde(rename = "@name")]
    pub name: String,
    #[serde(rename = "@addr")]
    pub addr: String,
    #[serde(rename = "@mask")]
    pub mask: String,
}


